diff -Naur ruby-1.9.3-p547.original/common.mk ruby-1.9.3-p547.htm/common.mk
--- ruby-1.9.3-p547.original/common.mk	2014-05-14 17:38:00.000000000 +0900
+++ ruby-1.9.3-p547.htm/common.mk	2014-09-12 06:37:35.905002000 +0900
@@ -94,6 +94,7 @@
 		vm_dump.$(OBJEXT) \
 		thread.$(OBJEXT) \
 		cont.$(OBJEXT) \
+		htm_util.$(OBJEXT) \
 		$(BUILTIN_ENCOBJS) \
 		$(BUILTIN_TRANSOBJS) \
 		$(MISSING)
@@ -592,7 +593,7 @@
 ID_H_INCLUDES      = {$(VPATH)}id.h {$(VPATH)}vm_opts.h
 VM_CORE_H_INCLUDES = {$(VPATH)}vm_core.h {$(VPATH)}thread_$(THREAD_MODEL).h \
 		     {$(VPATH)}node.h {$(VPATH)}method.h {$(VPATH)}ruby_atomic.h \
-		     $(ID_H_INCLUDES)
+		     $(ID_H_INCLUDES) {$(VPATH)}htm_util.h
 
 array.$(OBJEXT): {$(VPATH)}array.c $(RUBY_H_INCLUDES) {$(VPATH)}util.h \
   $(ENCODING_H_INCLUDES) {$(VPATH)}internal.h
@@ -718,6 +719,7 @@
 cont.$(OBJEXT): {$(VPATH)}cont.c $(RUBY_H_INCLUDES) \
   $(VM_CORE_H_INCLUDES) {$(VPATH)}gc.h {$(VPATH)}eval_intern.h \
   {$(VPATH)}debug.h {$(VPATH)}internal.h
+htm_util.$(OBJEXT): {$(VPATH)}htm_util.c {$(VPATH)}htm_util.h
 time.$(OBJEXT): {$(VPATH)}time.c $(RUBY_H_INCLUDES) \
   $(ENCODING_H_INCLUDES) {$(VPATH)}timev.h {$(VPATH)}internal.h
 util.$(OBJEXT): {$(VPATH)}util.c $(RUBY_H_INCLUDES) {$(VPATH)}util.h \
diff -Naur ruby-1.9.3-p547.original/compile.c ruby-1.9.3-p547.htm/compile.c
--- ruby-1.9.3-p547.original/compile.c	2013-01-11 17:13:17.000000000 +0900
+++ ruby-1.9.3-p547.htm/compile.c	2014-09-12 06:37:35.905002000 +0900
@@ -6,6 +6,7 @@
   created at: 04/01/01 03:42:15 JST
 
   Copyright (C) 2004-2007 Koichi Sasada
+  Copyright (c) IBM Corp. 2014.
 
 **********************************************************************/
 
@@ -1571,6 +1572,14 @@
     iseq->insn_info_table = insn_info_table;
     iseq->insn_info_size = k;
     iseq->stack_max = stack_max;
+#ifdef HTM_GVL
+    iseq->htm_counters = ALLOC_N(int64_t, pos);
+    MEMZERO(iseq->htm_counters, int64_t, pos);
+#ifdef HTM_GVL_INSN_STATS
+    iseq->htm_insn_stats_counters = ALLOC_N(htm_insn_stats_t, pos);
+    MEMZERO(iseq->htm_insn_stats_counters, htm_insn_stats_t, pos);
+#endif
+#endif
 
     return COMPILE_OK;
 }
diff -Naur ruby-1.9.3-p547.original/configure.in ruby-1.9.3-p547.htm/configure.in
--- ruby-1.9.3-p547.original/configure.in	2014-02-14 20:52:53.000000000 +0900
+++ ruby-1.9.3-p547.htm/configure.in	2014-09-12 06:37:35.905002000 +0900
@@ -991,6 +991,13 @@
 AC_ARG_ENABLE(pthread,
        AS_HELP_STRING([--enable-pthread], [obsolete, and ignored]))
 
+AC_ARG_ENABLE(htm-gvl,
+       AS_HELP_STRING([--enable-htm-gvl], [use hardware transactional memory for GVL]),
+       [use_htm_gvl=$enableval])
+if test "$use_htm_gvl" = yes; then
+     RUBY_APPEND_OPTION(XCFLAGS, -DHTM_GVL)
+fi
+
 dnl Checks for libraries.
 AS_CASE(["$target_os"],[*bsd*|dragonfly*],[],[ac_cv_func_daemon=no])
 
diff -Naur ruby-1.9.3-p547.original/cont.c ruby-1.9.3-p547.htm/cont.c
--- ruby-1.9.3-p547.original/cont.c	2012-02-16 07:34:48.000000000 +0900
+++ ruby-1.9.3-p547.htm/cont.c	2014-09-12 06:37:35.905002000 +0900
@@ -6,12 +6,13 @@
   created at: Thu May 23 09:03:43 2007
 
   Copyright (C) 2007 Koichi Sasada
+  Copyright (c) IBM Corp. 2014.
 
 **********************************************************************/
 
 #include "ruby/ruby.h"
-#include "internal.h"
 #include "vm_core.h"
+#include "internal.h"
 #include "gc.h"
 #include "eval_intern.h"
 
@@ -138,7 +139,14 @@
     if (ptr) {
 	rb_context_t *cont = ptr;
 	rb_gc_mark(cont->value);
+#ifdef HTM_GVL
+	cont->saved_thread.gc_safe_point_reached = 1;
+#endif
+#ifdef ALIGN_RB_THREAD_T
+	rb_thread_mark_aligned(&cont->saved_thread, 0);
+#else
 	rb_thread_mark(&cont->saved_thread);
+#endif
 	rb_gc_mark(cont->saved_thread.self);
 
 	if (cont->vm_stack) {
diff -Naur ruby-1.9.3-p547.original/ext/dbm/extconf.rb ruby-1.9.3-p547.htm/ext/dbm/extconf.rb
--- ruby-1.9.3-p547.original/ext/dbm/extconf.rb	2012-02-17 10:16:19.000000000 +0900
+++ ruby-1.9.3-p547.htm/ext/dbm/extconf.rb	2014-09-12 06:37:35.905002000 +0900
@@ -90,16 +90,16 @@
     decltype && try_link(<<"SRC", opt, &b) or
 #{headers}
 /*top*/
-#{MAIN_DOES_NOTHING}
 extern int t(void);
 int t(void) { #{decltype["volatile p"]}; p = (#{decltype[]})#{func}; return 0; }
+#{MAIN_DOES_NOTHING "t"}
 SRC
     call && try_link(<<"SRC", opt, &b)
 #{headers}
 /*top*/
-#{MAIN_DOES_NOTHING}
 extern int t(void);
 int t(void) { #{call}; return 0; }
+#{MAIN_DOES_NOTHING "t"}
 SRC
   end
 
@@ -108,9 +108,9 @@
     try_compile(<<"SRC", opt, &b)
 #{headers}
 /*top*/
-#{MAIN_DOES_NOTHING}
 extern int t(void);
 int t(void) { const volatile void *volatile p; p = &(&#{var})[0]; return 0; }
+#{MAIN_DOES_NOTHING "t"}
 SRC
   end
 
diff -Naur ruby-1.9.3-p547.original/gc.c ruby-1.9.3-p547.htm/gc.c
--- ruby-1.9.3-p547.original/gc.c	2014-01-30 20:04:17.000000000 +0900
+++ ruby-1.9.3-p547.htm/gc.c	2014-09-12 06:37:35.905002000 +0900
@@ -8,6 +8,7 @@
   Copyright (C) 1993-2007 Yukihiro Matsumoto
   Copyright (C) 2000  Network Applied Communication Laboratory, Inc.
   Copyright (C) 2000  Information-technology Promotion Agency, Japan
+  Copyright (c) IBM Corp. 2014.
 
 **********************************************************************/
 
@@ -87,6 +88,7 @@
     unsigned int initial_heap_min_slots;
     unsigned int initial_free_min;
     int gc_stress;
+    int do_not_shrink_heap;
 } ruby_gc_params_t;
 
 ruby_gc_params_t initial_params = {
@@ -96,6 +98,7 @@
 #if defined(ENABLE_VM_OBJSPACE) && ENABLE_VM_OBJSPACE
     FALSE,
 #endif
+    FALSE,
 };
 
 #define nomem_error GET_VM()->special_exceptions[ruby_error_nomemory]
@@ -424,6 +427,7 @@
 #define initial_malloc_limit	initial_params.initial_malloc_limit
 #define initial_heap_min_slots	initial_params.initial_heap_min_slots
 #define initial_free_min	initial_params.initial_free_min
+#define do_not_shrink_heap	initial_params.do_not_shrink_heap
 
 static void rb_objspace_call_finalizer(rb_objspace_t *objspace);
 
@@ -447,6 +451,7 @@
 rb_gc_set_params(void)
 {
     char *malloc_limit_ptr, *heap_min_slots_ptr, *free_min_ptr;
+    char *no_shrink_heap_ptr;
 
     if (rb_safe_level() > 0) return;
 
@@ -482,6 +487,11 @@
 	    initial_free_min = free_min_i;
 	}
     }
+
+    no_shrink_heap_ptr = getenv("RUBY_DO_NOT_SHRINK_HEAP");
+    if (no_shrink_heap_ptr) {
+	do_not_shrink_heap = TRUE;
+    }
 }
 
 #if defined(ENABLE_VM_OBJSPACE) && ENABLE_VM_OBJSPACE
@@ -1184,11 +1194,39 @@
     return during_gc;
 }
 
+#ifdef USE_THREAD_LOCAL_HEAP
+static inline void
+fill_thread_local_heap(rb_thread_t *th, rb_objspace_t *objspace)
+{
+#define NUM_TLH_OBJECTS 256
+    int tlh_count;
+    void *old_tlh_free_list;
+    RVALUE *current_free_list;
+    RVALUE *prev_free_list;
+
+    old_tlh_free_list = th->tlh_free_list;
+    current_free_list = freelist;
+    prev_free_list = NULL;
+    for (tlh_count = 0; tlh_count < NUM_TLH_OBJECTS; tlh_count++) {
+	if (! current_free_list)
+	    break;
+	prev_free_list = current_free_list;
+	current_free_list = current_free_list->as.free.next;
+    }
+    th->tlh_free_list = (void *)freelist;
+    freelist = current_free_list;
+    prev_free_list->as.free.next = old_tlh_free_list;
+}
+#endif
+
 #define RANY(o) ((RVALUE*)(o))
 
 VALUE
 rb_newobj(void)
 {
+#ifdef USE_THREAD_LOCAL_HEAP
+    rb_thread_t *th = GET_THREAD();
+#endif
     rb_objspace_t *objspace = &rb_objspace;
     VALUE obj;
 
@@ -1205,6 +1243,20 @@
 	}
     }
 
+#ifdef USE_THREAD_LOCAL_HEAP
+    if (! th->tlh_free_list) {
+	if (UNLIKELY(!freelist)) {
+	    if (!gc_lazy_sweep(objspace)) {
+		during_gc = 0;
+		rb_memerror();
+	    }
+	}
+
+	fill_thread_local_heap(th, objspace);
+    }
+    obj = (VALUE)th->tlh_free_list;
+    th->tlh_free_list = ((RVALUE *)th->tlh_free_list)->as.free.next;
+#else
     if (UNLIKELY(!freelist)) {
 	if (!gc_lazy_sweep(objspace)) {
 	    during_gc = 0;
@@ -1214,6 +1266,7 @@
 
     obj = (VALUE)freelist;
     freelist = freelist->as.free.next;
+#endif /* USE_THREAD_LOCAL_HEAP */
 
     MEMZERO((void*)obj, RVALUE, 1);
 #ifdef GC_DEBUG
@@ -2161,7 +2214,8 @@
         p++;
     }
     if (final_num + free_num == sweep_slot->limit &&
-        objspace->heap.free_num > objspace->heap.do_heap_free) {
+        objspace->heap.free_num > objspace->heap.do_heap_free
+	&& ! do_not_shrink_heap) {
         RVALUE *pp;
 
         for (pp = deferred_final_list; pp != final; pp = pp->as.free.next) {
@@ -2539,6 +2593,18 @@
 #endif
 }
 
+#ifdef USE_THREAD_LOCAL_HEAP
+static int
+thread_free_tlh(st_data_t key, st_data_t val, st_data_t data)
+{
+    rb_thread_t *th;
+    GetThreadPtr((VALUE)key, th);
+    th->tlh_free_list = NULL;
+
+    return ST_CONTINUE;
+}
+#endif
+
 static void
 gc_marks(rb_objspace_t *objspace)
 {
@@ -2548,6 +2614,9 @@
 
     objspace->heap.live_num = 0;
     objspace->count++;
+#ifdef USE_THREAD_LOCAL_HEAP
+    st_foreach(GET_THREAD()->vm->living_threads, thread_free_tlh, (st_index_t)0);
+#endif
 
 
     SET_STACK_END;
diff -Naur ruby-1.9.3-p547.original/htm_ia32_stat.h ruby-1.9.3-p547.htm/htm_ia32_stat.h
--- ruby-1.9.3-p547.original/htm_ia32_stat.h	1970-01-01 09:00:00.000000000 +0900
+++ ruby-1.9.3-p547.htm/htm_ia32_stat.h	2014-09-17 11:58:21.318459000 +0900
@@ -0,0 +1,8 @@
+/*  Copyright (c) IBM Corp. 2014. */
+HTM_IA32_STAT(XABORT)
+HTM_IA32_STAT(TRANSIENT)
+HTM_IA32_STAT(MEMADDR_CONFLICT)
+HTM_IA32_STAT(BUFFER_OVERFLOW)
+HTM_IA32_STAT(HIT_DEBUG_BREAKPOINT)
+HTM_IA32_STAT(DURING_NESTED_TRANSACTION)
+HTM_IA32_STAT(OTHER)
diff -Naur ruby-1.9.3-p547.original/htm_ppc_stat.h ruby-1.9.3-p547.htm/htm_ppc_stat.h
--- ruby-1.9.3-p547.original/htm_ppc_stat.h	1970-01-01 09:00:00.000000000 +0900
+++ ruby-1.9.3-p547.htm/htm_ppc_stat.h	2014-09-17 11:58:21.318459000 +0900
@@ -0,0 +1,14 @@
+/*  Copyright (c) IBM Corp. 2014. */
+/* See 5.4.2 */
+HTM_PPC_STAT(Failure_Persistent)
+HTM_PPC_STAT(Disallowed)
+HTM_PPC_STAT(Nesting_Overflow)
+HTM_PPC_STAT(Footprint_Overflow)
+HTM_PPC_STAT(Self_Induced_Conflict)
+HTM_PPC_STAT(Non_Transactional_Conflict)
+HTM_PPC_STAT(Transaction_Conflict)
+HTM_PPC_STAT(Translation_Invalidation_Conflict)
+HTM_PPC_STAT(Implementation_Specific)
+HTM_PPC_STAT(Instruction_Fetch_Conflict)
+HTM_PPC_STAT(Tabort_Treclaim)
+HTM_PPC_STAT(Other)
diff -Naur ruby-1.9.3-p547.original/htm_util.c ruby-1.9.3-p547.htm/htm_util.c
--- ruby-1.9.3-p547.original/htm_util.c	1970-01-01 09:00:00.000000000 +0900
+++ ruby-1.9.3-p547.htm/htm_util.c	2014-09-17 07:43:11.923270000 +0900
@@ -0,0 +1,229 @@
+/*  Copyright (c) IBM Corp. 2014. */
+#include <stdio.h>
+#include <stdint.h>
+#include <assert.h>
+#include "htm_util.h"
+
+#if defined(__370__)
+
+static int tbegin_impl(void *diag);
+#if 1
+/* lghi gpr3,0; tbegin 0(gpr1),FF00; brc 0x8,$+16; lghi gpr3,2; brc 0x6,$+8; lghi gpr3,3 */
+#pragma mc_func tbegin_impl {"A7390000" "E5601000FF00" "A7840008" "A7390002" "A7640004" "A7390003"}
+#else
+/* lghi gpr3,0; tbegin 0(gpr1),FF00; brc 0x8,$+24; lghi gpr3,1; brc 0x4,$+16; lghi gpr3,2; brc 0x2,$+8; lghi gpr3,3 */
+#pragma mc_func tbegin_impl {"A7390000" "E5601000FF00" "A784000C" "A7390001" "A7440008" "A7390002" "A7240004" "A7390003"}
+#endif
+
+static int tbegin_fp_impl(void *diag);
+#if 1
+#pragma mc_func tbegin_fp_impl {"A7390000" "E5601000FF04" "A7840008" "A7390002" "A7640004" "A7390003"}
+#else
+#pragma mc_func tbegin_fp_impl {"A7390000" "E5601000FF04" "A784000C" "A7390001" "A7440008" "A7390002" "A7240004" "A7390003"}
+#endif
+
+static void tend_impl(void *diag);
+#pragma mc_func tend_impl {"B2F81000"}  /* tend 0(gpr1) */
+
+static void tabort_impl(int code);
+#pragma mc_func tabort_impl {"B2FC1000"}  /* tabort 0(gpr1) */
+
+static void tabort_no_abend_in_no_tx_impl(int code);
+/* tbegin 0(gpr0),FF00; brc 0x7,$+8; tabort 0(gpr1) */
+#pragma mc_func tabort_no_abend_in_no_tx_impl {"E5600000FF00" "A7740004" "B2FC1000"}
+
+static void non_tx_store_impl(int64_t *addr, int64_t data);
+#pragma mc_func non_tx_store_impl { "E32010000025" }  /* ntstg gpr2,0(gpr1) */
+
+static uint64_t
+get_transaction_nesting_depth_impl();
+#pragma mc_func get_transaction_nesting_depth_impl { "B2EC0030" }  /* ETNDG gpr3 */
+
+/* std fpr8,0(gpr1); ...; std fpr15,56(gpr1) */
+static void save_preserved_fpr_impl(uint64_t *addr);
+#pragma mc_func save_preserved_fpr_impl {"60801000" "60901008" "60A01010" "60B01018" "60C01020" "60D01028" "60E01030" "60F01038"}
+
+/* ld fpr8,0(gpr1); ...; ld fpr15,56(gpr1) */
+static void restore_preserved_fpr_impl(uint64_t *addr);
+#pragma mc_func restore_preserved_fpr_impl {"68801000" "68901008" "68A01010" "68B01018" "68C01020" "68D01028" "68E01030" "68F01038"}
+
+int
+tbegin(TransactionDiagnosticInfo *diag)
+{
+  /*return tbegin_impl(diag);*/
+  return tbegin_fp_impl(diag);
+}
+
+#if defined(__370__) && __COMPILER_VER__ >= 0x410d0000
+/* Macro-expanded to intrinsic */
+#else
+void
+tend(void)
+{
+  TransactionDiagnosticInfo *diag = NULL;
+  tend_impl(diag);
+}
+#endif
+
+void
+tabort(uint64_t code)
+{
+  tabort_impl(code);
+}
+
+void
+tabort_no_abend_in_no_tx(uint64_t code)
+{
+  tabort_no_abend_in_no_tx_impl(code);
+}
+
+#if defined(__370__) && __COMPILER_VER__ >= 0x410d0000
+/* Macro-expanded to intrinsic */
+#else
+void
+non_tx_store(int64_t *addr, int64_t data)
+{
+  /* addr must be 8-byte aligned */
+  non_tx_store_impl(addr, data);
+}
+#endif
+
+#if defined(__370__) && __COMPILER_VER__ >= 0x410d0000
+/* Macro-expanded to intrinsic */
+#else
+int
+get_transaction_nesting_depth(void)
+{
+  uint64_t ret;
+
+  ret = get_transaction_nesting_depth_impl();
+  return ret & 0xFFFF;
+}
+#endif
+
+void
+save_preserved_fpr(uint64_t *addr)
+{
+  save_preserved_fpr_impl(addr);
+}
+
+void
+restore_preserved_fpr(uint64_t *addr)
+{
+  restore_preserved_fpr_impl(addr);
+}
+
+#elif defined(__x86_64__)  /* __370__ */
+
+/* Everything is in htm_util.h */
+
+#elif defined(__PPC__) || defined(_ARCH_PPC)
+
+/* Everything is in htm_util.h */
+
+#else /* __370__ , __x86_64, __PPC__ */
+
+#error
+
+#endif  /* __370__ -> __x86_64 -> __PPC__ */
+
+void
+countHTMFailures(TransactionDiagnosticInfo *diag, uint64_t *counters)
+{
+#if defined(__370__)
+  uint64_t abortCode = diag->transactionAbortCode;
+  if (diag->format != 1) {
+    counters[0]++;
+  } else if (abortCode <= 2) {
+    counters[abortCode]++;
+    /* No such abort code as 3  */
+  } else if (abortCode <= 16) {
+    counters[abortCode - 1]++;
+  } else if (abortCode == 255) {
+    counters[16]++;
+  } else {
+    counters[17]++;
+  }
+#elif defined(__x86_64__)
+  uint64_t abortCode = diag->transactionAbortCode;
+  counters[0] += (abortCode & XABORT_EXPLICIT) ? 1 : 0;
+  counters[1] += (abortCode & XABORT_RETRY) ? 1 : 0;
+  counters[2] += (abortCode & XABORT_CONFLICT) ? 1 : 0;
+  counters[3] += (abortCode & XABORT_CAPACITY) ? 1 : 0;
+  counters[4] += (abortCode & XABORT_DEBUG) ? 1 : 0;
+  counters[5] += (abortCode & XABORT_NESTED) ? 1 : 0;
+  counters[6] += (abortCode & (XABORT_EXPLICIT | XABORT_RETRY | XABORT_CONFLICT | XABORT_CONFLICT | XABORT_DEBUG | XABORT_NESTED)) ? 0 : 1;  /* Other */
+#elif defined(__PPC__) || defined(_ARCH_PPC)
+  uint64_t texasr = diag->transactionAbortCode;
+#define PPC_BFIELD(x) ((0x1ULL)<<(63-x))
+  counters[ 0] += (texasr & PPC_BFIELD( 7))? 1 : 0;
+  counters[ 1] += (texasr & PPC_BFIELD( 8))? 1 : 0;
+  counters[ 2] += (texasr & PPC_BFIELD( 9))? 1 : 0;
+  counters[ 3] += (texasr & PPC_BFIELD(10))? 1 : 0;
+  counters[ 4] += (texasr & PPC_BFIELD(11))? 1 : 0;
+  counters[ 5] += (texasr & PPC_BFIELD(12))? 1 : 0;
+  counters[ 6] += (texasr & PPC_BFIELD(13))? 1 : 0;
+  counters[ 7] += (texasr & PPC_BFIELD(14))? 1 : 0;
+  counters[ 8] += (texasr & PPC_BFIELD(15))? 1 : 0;
+  counters[ 9] += (texasr & PPC_BFIELD(16))? 1 : 0;
+  counters[10] += (texasr & PPC_BFIELD(31))? 1 : 0;
+  counters[11] += (texasr & (PPC_BFIELD(7) | PPC_BFIELD(8) | PPC_BFIELD(9) | PPC_BFIELD(10) | PPC_BFIELD(11) | PPC_BFIELD(12) | PPC_BFIELD(13) | PPC_BFIELD(14) | PPC_BFIELD(15) | PPC_BFIELD(16) | PPC_BFIELD(31))) ? 0 : 1;  /* Other */
+#else
+#error
+#endif
+}
+
+const char *
+getHTMFailureName(int id)
+{
+  const char *reason_strings[] = {
+#if defined(__370__)
+    "TDB_not_set",
+    "Restart_interruption",
+    "External_interruption",
+    "Program_interruption",
+    "Machine-check_interruption",
+    "I/O_interruption",
+    "Fetch_overflow",
+    "Store_overflow",
+    "Fetch_conflict",
+    "Store_conflict",
+    "Restricted_instruction",
+    "Program-interruption_condition",
+    "Nesting_depth_exceeded",
+    "Cache_fetch-related",
+    "Cache_store-related",
+    "Cache_other",
+    "Undetermined_condition",
+    "TABORT_instruction"
+#elif defined(__x86_64__)
+    "XABORT",
+    "TRANSIENT",
+    "MEMADDR_CONFLICT",
+    "BUFFER_OVERFLOW",
+    "HIT_DEBUG_BREAKPOINT",
+    "DURING_NESTED_TRANSACTION",
+    "OTHER"
+#elif defined(__PPC__) || defined(_ARCH_PPC)
+    "Failure_Persistent",
+    "Disallowed",
+    "Nesting_Overflow",
+    "Footprint_Overflow",
+    "Self_Induced_Conflict",
+    "Non_Tx_Conflict",
+    "Tx_Conflict",
+    "Translation_Invalidation",
+    "Implementation_Specific",
+    "Instruction_Fetch_Conflict",
+    "Tabort_Treclaim",
+    "Other"
+#else
+#error
+#endif
+  };
+
+  if (id < 0 || NUM_HTM_FAILURE_REASONS <= id) {
+    return NULL;
+  }
+  return reason_strings[id];
+}
diff -Naur ruby-1.9.3-p547.original/htm_util.h ruby-1.9.3-p547.htm/htm_util.h
--- ruby-1.9.3-p547.original/htm_util.h	1970-01-01 09:00:00.000000000 +0900
+++ ruby-1.9.3-p547.htm/htm_util.h	2014-09-17 07:43:11.923270000 +0900
@@ -0,0 +1,193 @@
+/*  Copyright (c) IBM Corp. 2014. */
+#ifndef _HTM_UTIL_H
+#define _HTM_UTIL_H
+
+#include <stdint.h>
+#if defined(__370__) && __COMPILER_VER__ >= 0x410d0000
+#include <builtins.h>
+#endif
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+typedef struct {
+#if defined(__370__)
+  uint8_t format;
+  uint8_t flags;
+  uint16_t reserved0;
+  uint16_t reserved1;
+  uint16_t transactionNestingDepth;
+  uint64_t transactionAbortCode;
+  uint64_t conflictToken;
+  uint64_t abortedTransactionInstructionAddress;
+  uint8_t EAID;
+  uint8_t DXC;
+  uint16_t reserved2;
+  uint32_t programInterruptionIdentification;
+  uint64_t translationExceptionIdentification;
+  uint64_t breakingEventAddress;
+  uint64_t reserved3[8];
+  uint32_t reserved4;
+  uint16_t reserved5;
+  uint8_t reserved6;
+  uint8_t LSUAbortCode;
+  uint64_t generalRegisters[16];
+#elif defined(__x86_64)
+  uint64_t transactionAbortCode;
+#elif defined(__PPC__) || defined(_ARCH_PPC)
+  uint64_t transactionAbortCode;
+  uint64_t abortedTransactionInstructionAddress;
+#endif
+} TransactionDiagnosticInfo;
+
+/*
+  int tbegin(TransactionDiagnosticInfo *diag);
+  Returns 0 for success
+          1 for inderminate
+          2 for transient abort
+	  3 for persistent abort
+ */
+
+#if defined(__370__)
+
+int tbegin(TransactionDiagnosticInfo *diag);
+#if __COMPILER_VER__ >= 0x410d0000
+#define tend() __TM_end()
+#else
+void tend();
+#endif
+void tabort(uint64_t code);
+void tabort_no_abend_in_no_tx(uint64_t code);
+#if __COMPILER_VER__ >= 0x410d0000
+/* addr must be 8-byte aligned */
+#define non_tx_store(addr, data) __TM_non_transactional_store((addr), (long long)data)
+#else
+void non_tx_store(int64_t *addr, int64_t data);
+#endif
+#if __COMPILER_VER__ >= 0x410d0000
+#define get_transaction_nesting_depth() __TM_nesting_depth(NULL)
+#else
+int get_transaction_nesting_depth();
+#endif
+void save_preserved_fpr(uint64_t *addr);
+void restore_preserved_fpr(uint64_t *addr);
+
+#define NUM_HTM_FAILURE_REASONS 18
+
+#elif defined(__x86_64)
+
+#define XABORT_EXPLICIT	0x01
+#define XABORT_RETRY	0x02
+#define XABORT_CONFLICT	0x04
+#define XABORT_CAPACITY	0x08
+#define XABORT_DEBUG	0x10
+#define XABORT_NESTED	0x20
+
+static inline int tbegin(TransactionDiagnosticInfo *diag)
+{
+  unsigned int xbegin_result;
+
+  xbegin_result = 0xffffffff;
+  asm volatile("mov %0, %%eax;"
+	       ".byte 0xc7; .byte 0xf8; .int 0x00000000;" /* xbegin */
+	       "mov %%eax, %0"
+	       : "+r"(xbegin_result)
+	       :
+	       : "%eax");
+  if (xbegin_result == 0xffffffff)
+    return 0;
+  else {
+    diag->transactionAbortCode = xbegin_result;
+    if (xbegin_result & XABORT_RETRY)
+      return 2;
+    return 3;
+  }
+}
+
+#define tend() do {							\
+    asm volatile(".byte 0x0f; .byte 0x01; .byte 0xd5" :: ); /* xend */	\
+  } while (0)
+
+#define tabort(code) do {						\
+    /* xabort's argument must be an 8-bit immediate */\
+    asm volatile(".byte 0xc6; .byte 0xf8; .byte %P0" :: "i"(code & 0xff)); /* xabort */ \
+  } while (0)
+
+#define NUM_HTM_FAILURE_REASONS 7
+
+#elif defined(__PPC__) || defined(_ARCH_PPC)
+
+static inline int tbegin(TransactionDiagnosticInfo *diag)
+{
+  uint32_t tbegin_status;
+
+  asm volatile(".long 0x7c00051d;"
+	       "mfcr %0"
+	       :"=r"(tbegin_status): : "cr0");	// tbegin. 0
+  if (! (tbegin_status & 0x20000000U))
+    return 0;
+  else {
+#ifdef _ARCH_PPC64
+    uint64_t texasr;
+    uint64_t tfiar;
+
+    asm volatile("mfspr %0,130;"
+		 "mfspr %1,129"
+		 :"=r"(texasr), "=r"(tfiar): );
+    diag->transactionAbortCode = texasr;
+#else
+    uint32_t texasr;
+    uint32_t texasru;
+    uint32_t tfiar;
+
+    asm volatile("mfspr %0,130;"
+		 "mfspr %1,131;"
+		 "mfspr %2,129"
+		 :"=r"(texasr), "=r"(texasru), "=r"(tfiar): );
+    diag->transactionAbortCode = (uint64_t)texasru << 32 | (uint64_t)texasr;
+#endif
+    diag->abortedTransactionInstructionAddress = (uint64_t)tfiar & ~0x3ULL;
+    if (texasr & 0x0100000000000000ULL)
+      return 3;
+    return 2;
+  }
+}
+
+/* tend. 0 */
+#define tend() do {				\
+    asm volatile(".long 0x7c00055d":::"cr0" );	\
+  } while (0)
+
+static inline void tabort(uint64_t code)
+{
+  uint64_t int_code = code << 56;
+  asm volatile("mr 3,%0;"
+	       ".long 0x7c03071d": : "r" (int_code) : "r3", "cr0"); // tabort. 3
+  //asm(".long 0x7c00071d":::"cr0" ); // tabort. 0
+}
+
+#define tsuspend() do {				\
+    asm volatile (".long 0x7C0005DD");		\
+  } while (0)
+
+#define tresume() do {				\
+    asm volatile (".long 0x7C2005DD");		\
+  } while (0)
+
+#define NUM_HTM_FAILURE_REASONS 12
+
+#else
+
+#error
+
+#endif
+
+void countHTMFailures(TransactionDiagnosticInfo *diag, uint64_t *counters);
+const char *getHTMFailureName(int id);
+
+#ifdef __cplusplus
+}
+#endif
+
+#endif /* _HTM_UTIL_H */
diff -Naur ruby-1.9.3-p547.original/include/ruby/ruby.h ruby-1.9.3-p547.htm/include/ruby/ruby.h
--- ruby-1.9.3-p547.original/include/ruby/ruby.h	2013-06-26 17:11:48.000000000 +0900
+++ ruby-1.9.3-p547.htm/include/ruby/ruby.h	2014-09-12 06:37:35.905002000 +0900
@@ -8,6 +8,7 @@
   Copyright (C) 1993-2008 Yukihiro Matsumoto
   Copyright (C) 2000  Network Applied Communication Laboratory, Inc.
   Copyright (C) 2000  Information-technology Promotion Agency, Japan
+  Copyright (c) IBM Corp. 2014.
 
 **********************************************************************/
 
@@ -832,6 +833,34 @@
     TypedData_Wrap_Struct((klass),(data_type),(sval))\
 )
 
+/* We should #ifdef ALIGN_RB_THREAD_T,
+   but this file does not include vm_core.h. */
+#if defined(__370__)
+#define TypedData_Make_Struct_Cache_Line_Aligned(klass, type, data_type, sval) (\
+    (sval) = ALLOC_With_Cache_Line_Padding(type),\
+    memset((sval), 0, sizeof(type) + 256 * 2),\
+    TypedData_Wrap_Struct((klass),(data_type),(sval))\
+)
+#elif defined(__x86_64__) || defined(__CYGWIN__)
+#define TypedData_Make_Struct_Cache_Line_Aligned(klass, type, data_type, sval) (\
+    (sval) = ALLOC_With_Cache_Line_Padding(type),\
+    memset((sval), 0, sizeof(type) + 64 * 2),\
+    TypedData_Wrap_Struct((klass),(data_type),(sval))\
+)
+#elif defined(__PPC__) || defined(_ARCH_PPC)
+#define TypedData_Make_Struct_Cache_Line_Aligned(klass, type, data_type, sval) (\
+    (sval) = ALLOC_With_Cache_Line_Padding(type),\
+    memset((sval), 0, sizeof(type) + 128 * 2),\
+    TypedData_Wrap_Struct((klass),(data_type),(sval))\
+)
+#else
+#define TypedData_Make_Struct_Cache_Line_Aligned(klass, type, data_type, sval) (\
+    (sval) = ALLOC(type),\
+    memset((sval), 0, sizeof(type)),\
+    TypedData_Wrap_Struct((klass),(data_type),(sval))\
+)
+#endif
+
 #define Data_Get_Struct(obj,type,sval) do {\
     Check_Type((obj), T_DATA); \
     (sval) = (type*)DATA_PTR(obj);\
@@ -1033,6 +1062,17 @@
 
 #define ALLOC_N(type,n) ((type*)xmalloc2((n),sizeof(type)))
 #define ALLOC(type) ((type*)xmalloc(sizeof(type)))
+/* We should #ifdef ALIGN_RB_THREAD_T,
+   but this file does not include vm_core.h. */
+#if defined(__370__)
+#define ALLOC_With_Cache_Line_Padding(type) ((type*)xmalloc(sizeof(type) + 256 * 2))
+#elif defined(__x86_64__) || defined(__CYGWIN__)
+#define ALLOC_With_Cache_Line_Padding(type) ((type*)xmalloc(sizeof(type) + 64 * 2))
+#elif defined(__PPC__) || defined(_ARCH_PPC)
+#define ALLOC_With_Cache_Line_Padding(type) ((type*)xmalloc(sizeof(type) + 128 * 2))
+#else
+#define ALLOC_With_Cache_Line_Padding(type) ((type*)xmalloc(sizeof(type)))
+#endif
 #define REALLOC_N(var,type,n) ((var)=(type*)xrealloc2((char*)(var),(n),sizeof(type)))
 
 #define ALLOCA_N(type,n) ((type*)alloca(sizeof(type)*(n)))
@@ -1166,8 +1206,11 @@
 
 VALUE *rb_ruby_verbose_ptr(void);
 VALUE *rb_ruby_debug_ptr(void);
+int   *rb_ruby_use_gvl_ptr(void);
 #define ruby_verbose (*rb_ruby_verbose_ptr())
 #define ruby_debug   (*rb_ruby_debug_ptr())
+#define ruby_use_gvl (*rb_ruby_use_gvl_ptr())
+
 
 PRINTF_ARGS(NORETURN(void rb_raise(VALUE, const char*, ...)), 2, 3);
 PRINTF_ARGS(NORETURN(void rb_fatal(const char*, ...)), 1, 2);
diff -Naur ruby-1.9.3-p547.original/insns.def ruby-1.9.3-p547.htm/insns.def
--- ruby-1.9.3-p547.original/insns.def	2013-02-22 14:42:27.000000000 +0900
+++ ruby-1.9.3-p547.htm/insns.def	2014-09-12 06:37:35.905002000 +0900
@@ -5,6 +5,7 @@
   created at: 04/01/01 01:17:55 JST
 
   Copyright (C) 2004-2007 Koichi Sasada
+  Copyright (c) IBM Corp. 2014.
 */
 
 /** ##skip
@@ -1091,7 +1092,11 @@
 	}
     }
 
+#ifdef HTM_GVL
+    RUBY_VM_CHECK_INTS_EXEC_CORE(&GET_OPERAND(-1));
+#else
     RUBY_VM_CHECK_INTS();
+#endif
     vm_pop_frame(th);
     RESTORE_REGS();
 }
@@ -1130,7 +1135,11 @@
 (VALUE throwobj)
 (VALUE val)
 {
+#ifdef HTM_GVL
+    RUBY_VM_CHECK_INTS_EXEC_CORE(&GET_OPERAND(-2));
+#else
     RUBY_VM_CHECK_INTS();
+#endif
     val = vm_throw(th, GET_CFP(), throw_state, throwobj);
     THROW_EXCEPTION(val);
     /* unreachable */
@@ -1151,7 +1160,11 @@
 ()
 ()
 {
+#ifdef HTM_GVL
+    RUBY_VM_CHECK_INTS_EXEC_CORE(&GET_OPERAND(-2));
+#else
     RUBY_VM_CHECK_INTS();
+#endif
     JUMP(dst);
 }
 
@@ -1167,7 +1180,11 @@
 ()
 {
     if (RTEST(val)) {
+#ifdef HTM_GVL
+        RUBY_VM_CHECK_INTS_EXEC_CORE(&GET_OPERAND(-2));
+#else
 	RUBY_VM_CHECK_INTS();
+#endif
 	JUMP(dst);
     }
 }
@@ -1184,7 +1201,11 @@
 ()
 {
     if (!RTEST(val)) {
+#ifdef HTM_GVL
+        RUBY_VM_CHECK_INTS_EXEC_CORE(&GET_OPERAND(-2));
+#else
 	RUBY_VM_CHECK_INTS();
+#endif
 	JUMP(dst);
     }
 }
@@ -1233,7 +1254,11 @@
     }
     else if (ic->ic_value.value == Qundef)
     {
-    	RUBY_VM_CHECK_INTS();
+#ifdef HTM_GVL
+        RUBY_VM_CHECK_INTS_EXEC_CORE(&GET_OPERAND(-3));
+#else
+	RUBY_VM_CHECK_INTS();
+#endif
     	rb_thread_schedule();
 	goto retry;
     }
diff -Naur ruby-1.9.3-p547.original/internal.h ruby-1.9.3-p547.htm/internal.h
--- ruby-1.9.3-p547.original/internal.h	2014-01-29 14:24:28.000000000 +0900
+++ ruby-1.9.3-p547.htm/internal.h	2014-09-12 06:37:35.905002000 +0900
@@ -6,6 +6,7 @@
   created at: Tue May 17 11:42:20 JST 2011
 
   Copyright (C) 2011 Yukihiro Matsumoto
+  Copyright (c) IBM Corp. 2014.
 
 **********************************************************************/
 
@@ -182,6 +183,11 @@
 void rb_clear_trace_func(void);
 VALUE rb_thread_backtrace(VALUE thval);
 VALUE rb_get_coverages(void);
+#ifdef HTM_GVL
+int rb_thread_alone_fast(void *th);
+void gvl_release(void *vm, void *th);
+void htm_gvl_acquire_multi_threads(void *th, VALUE *counter_addr);
+#endif
 
 /* thread_pthread.c, thread_win32.c */
 void Init_native_thread(void);
@@ -195,6 +201,9 @@
 void rb_vm_change_state(void);
 void rb_vm_inc_const_missing_count(void);
 void rb_thread_mark(void *th);
+#ifdef ALIGN_RB_THREAD_T
+void rb_thread_mark_aligned(void *th, int aligned);
+#endif
 const void **rb_vm_get_insns_address_table(void);
 
 /* vm_dump.c */
diff -Naur ruby-1.9.3-p547.original/iseq.c ruby-1.9.3-p547.htm/iseq.c
--- ruby-1.9.3-p547.original/iseq.c	2014-02-14 15:44:36.000000000 +0900
+++ ruby-1.9.3-p547.htm/iseq.c	2014-09-12 06:37:35.905002000 +0900
@@ -6,6 +6,7 @@
   created at: 2006-07-11(Tue) 09:00:03 +0900
 
   Copyright (C) 2006 Koichi Sasada
+  Copyright (c) IBM Corp. 2014.
 
 **********************************************************************/
 
@@ -58,6 +59,51 @@
     }
 }
 
+#ifdef HTM_GVL
+void
+iseq_get_insn_counters(int64_t *counter_addr, uint32_t *counter0, uint32_t *counter1, uint32_t *counter2)
+{
+    uint32_t *counter1_addr;
+    uint32_t *counter2_addr;
+
+    counter1_addr = (uint32_t *)counter_addr + 1;
+    counter2_addr = (uint32_t *)counter_addr;
+
+    *counter0 = *counter2_addr & 0xFF;
+    *counter1 = *counter1_addr;
+    *counter2 = *counter2_addr >> 8;
+}
+
+void
+iseq_print_counter(int64_t *counter_addr, const char *insn_name, rb_iseq_t *iseq, int pos)
+{
+    uint32_t counter0;
+    uint32_t counter1;
+    uint32_t counter2;
+
+#ifdef HTM_GVL_INSN_STATS
+    htm_insn_stats_t *insn_stats_counter;
+    extern htm_insn_stats_t htm_insn_stats_counter_for_null;
+    if (pos == -1) {
+	insn_stats_counter = &htm_insn_stats_counter_for_null;
+    } else {
+	insn_stats_counter = &iseq->htm_insn_stats_counters[pos];
+    }
+#endif
+
+    iseq_get_insn_counters(counter_addr, &counter0, &counter1, &counter2);
+    fprintf(stderr, "#HTM_INSN_STATS %p %p %s %u %u %u"
+#ifndef HTM_GVL_INSN_STATS
+	    "\n"
+#endif
+	    , iseq, counter_addr, insn_name, counter0, counter1, counter2);
+    /*fprintf(stderr, "%s %u\n", insn_name(iseq->iseq[pos]), (uint32_t)(counter >> 32));*/
+#ifdef HTM_GVL_INSN_STATS
+    fprintf(stderr, "  %u %u\n", insn_stats_counter->c32.c0, insn_stats_counter->c32.c1);
+#endif
+}
+#endif
+
 static void
 iseq_free(void *ptr)
 {
@@ -66,6 +112,79 @@
 
     if (ptr) {
 	iseq = ptr;
+#ifdef HTM_GVL
+	if (getenv("RUBY_PRINT_HTM_INSN_STATS") ||
+	    getenv("RH_ISTATS")) {
+	    size_t i;
+	    uint64_t sum_counter1 = 0, sum_counter2 = 0;
+	    for (i = 1; i < iseq->insn_info_size; i++) {
+		int pos = iseq->insn_info_table[i].position;
+		int offset = 0;
+		switch (iseq->iseq[pos]) {
+		case BIN(getlocal):
+		    offset = 2;
+		    break;
+		case BIN(getinstancevariable):
+		    offset = 3;
+		    break;
+		case BIN(getclassvariable):
+		    offset = 2;
+		    break;
+		case BIN(send):
+		    offset = 6;
+		    break;
+		case BIN(leave):
+		    offset = 1;
+		    break;
+		case BIN(throw):
+		    offset = 2;
+		    break;
+		case BIN(jump):
+		    offset = 2;
+		    break;
+		case BIN(branchif):
+		    offset = 2;
+		    break;
+		case BIN(branchunless):
+		    offset = 2;
+		    break;
+		case BIN(onceinlinecache):
+		    offset = 3;
+		    break;
+		case BIN(opt_plus):
+		    offset = 2;
+		    break;
+		case BIN(opt_minus):
+		    offset = 2;
+		    break;
+		case BIN(opt_mult):
+		    offset = 2;
+		    break;
+		case BIN(opt_aref):
+		    offset = 2;
+		    break;
+		}
+		if (offset != 0) {
+		    int64_t *counter_addr = &iseq->htm_counters[pos];
+		    uint32_t counter0;
+		    uint32_t counter1;
+		    uint32_t counter2;
+
+		    iseq_print_counter(counter_addr, insn_name(iseq->iseq[pos]), iseq, pos);
+		    iseq_get_insn_counters(counter_addr, &counter0, &counter1, &counter2);
+
+		    sum_counter1 += counter1;
+		    sum_counter2 += counter2;
+		} else {
+		    fprintf(stderr, "#HTM_INSN_STATS %p %p %s 0 0 0\n", iseq, &iseq->iseq_encoded[pos], insn_name(iseq->iseq[pos]));
+		}
+	    }
+	    fprintf(stderr, "#HTM_INSN_STATS ISEQ %p %" PRIu64 " %" PRIu64 "\n",
+		    iseq, sum_counter1, sum_counter2
+		    /*, RSTRING_PTR(iseq->name)*/
+		    /*, !NIL_P(iseq->filename) ? RSTRING_PTR(iseq->filename) : "null"*/);
+	}
+#endif
 	if (!iseq->orig) {
 	    /* It's possible that strings are freed */
 	    if (0) {
